package cz.upol.jj2.lab05;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.JTextField;

/**
 * Ukazka dalsich komponent a konceptu: dalsi layouty, textove vstupy, preddefinovane dialogy, ...
 */
public class BorderLayoutForm extends JFrame {

	private JPanel     mainPanel;
	private JTextField txtTop;
	private JTextArea  txtaCenter;
	private JLabel     lbBottom;
	private JButton    btnClear;
	private JButton    btnAdd;
	private JPanel     rightPanel;
	
	public BorderLayoutForm() {
		this.setTitle("Form #2");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
	
		// rozmisteni komponent po stranach okna
		mainPanel = new JPanel(new BorderLayout());
		
		// jednoradkovy textovy vstup
		txtTop = new JTextField("Vstup v horni casti okna");
		
		// viceradkove textove pole
		txtaCenter = new JTextArea("Hlavni cast okna\n");
		
		lbBottom = new JLabel("Text ve spodni casti okna");
		lbBottom.setOpaque(true); // nastavi, aby stitek mel pozadi
		lbBottom.setBackground(Color.BLACK);
		lbBottom.setForeground(Color.WHITE);
		
		// bocni panel obsahujici tlacitka
		rightPanel = new JPanel();
		btnAdd     = new JButton("add");
		btnClear   = new JButton("Clear");
		
		rightPanel.setLayout(new BoxLayout(rightPanel, BoxLayout.Y_AXIS));
		rightPanel.add(btnAdd);
		rightPanel.add(btnClear);
		
		// vlozi komponenty do panelu
		mainPanel.add(txtTop, BorderLayout.NORTH);
		mainPanel.add(rightPanel, BorderLayout.EAST);
		mainPanel.add(txtaCenter, BorderLayout.CENTER);
		mainPanel.add(lbBottom, BorderLayout.SOUTH);
		
		// navaze na tlacitka udalosti
		btnAdd.addActionListener(new ActionListener() {
			
			@Override
			public void actionPerformed(ActionEvent e) {
				System.out.println("Tlacitko add");
				String currentText = txtaCenter.getText();
				String inputText = txtTop.getText();
				txtaCenter.setText(currentText + "\n" + inputText);
			}
		});
		
		// lze pouzit i lambda vyrazy
		btnClear.addActionListener(e -> {
			System.out.println("Smazat");
			
			// uzitecna trida obsahujici radu preddefinovanych dialogu pro bezne situace
			// v tomto pripade se zobrazi dotaz, jestli opravdu provest operaci
			int outcome = JOptionPane.showConfirmDialog(BorderLayoutForm.this, "Opravdu smazat obsah?", "Pozor", JOptionPane.OK_CANCEL_OPTION);
			if (outcome == JOptionPane.OK_OPTION) txtaCenter.setText("");
		});
		
		this.setContentPane(mainPanel);
		this.setPreferredSize(new Dimension(400, 400));
		this.pack();
		
	}

}
