package cz.upol.jj2.lab05;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;

import javax.swing.*;

/**
 * Ukazka pouziti vlastniho dialogovoeho okna s moznosti navraceni vysledku.
 */
public class DialogExample extends JFrame {

	private JButton btnKnock;
	private JPanel mainPanel;

	private JLabel lblWelcome;


	public DialogExample()  {
		super();
		
		this.setTitle("Door knocker");
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		this.setPreferredSize(new Dimension(400, 400));

		btnKnock = new JButton("Knock knock!");
		//akce referenci na metodu
		btnKnock.addActionListener(this::knockAction);
		
		lblWelcome = new JLabel("A door with a brass knocker lies ahead of you.", SwingConstants.CENTER); //

		mainPanel = new JPanel(new BorderLayout());
		mainPanel.add(lblWelcome, BorderLayout.CENTER);
		mainPanel.add(btnKnock, BorderLayout.SOUTH);


		
		this.setContentPane(mainPanel);
		this.pack();
	}
	/**
	 * Udalost pro vyvolani dialogoveho formulare
	 */
	private void knockAction(ActionEvent e) {
		HelloDialog dlg = new HelloDialog(this); // vytvori dialog. parametr udava nadrazeny formular
		dlg.setModal(true);						     // dialog je modalni  - pred pokracovanim v tomto okne na nej musime reagovat
		dlg.setVisible(true);					     // pockame na reakci uzivatele
		if (dlg.getResult() != null) {                 // podivame se na reakci uzivatele
			lblWelcome.setText("Welcome " + dlg.getResult() + "!");
		} else {
			lblWelcome.setText("Very funny...");
		}
		
		dlg.dispose();
	}
}
