package cz.upol.jj2.lab05;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;

import javax.swing.*;

/**
 * Ukazky dalsich layoutu a funkcionality pro dialogova okna
 */
public class HelloDialog extends JDialog {

	private JPanel actionPanel = new JPanel();
	private JPanel inputPanel = new JPanel();

	private JLabel lblWho = new JLabel("Who's there?", SwingConstants.CENTER);
	private JButton btnAnswer;
	private JButton btnRun;
	
	private JTextField txtName;
	private JTextField txtSurname;
	private JLabel lblName;
	private JLabel lblSurname;
	
	private String result = null;
	
	public HelloDialog(JFrame parentFrame) {
		super(parentFrame);
		setTitle("Who is there?");
		
		lblName = new JLabel("Name");
		lblSurname = new JLabel("Surname");

		txtName = new JTextField();
		txtName.setColumns(25);
		txtSurname = new JTextField();
		txtSurname.setColumns(25);
		
		// ukazka GroupLayout - mrizka 2x2
		GroupLayout layout = new GroupLayout(inputPanel);
		inputPanel.setLayout(layout);
		layout.setAutoCreateContainerGaps(true);
		layout.setAutoCreateGaps(true);

		//horizontalni pohled
		layout.setHorizontalGroup(
				layout.createSequentialGroup()  //vedle sebe
						.addGroup(layout.createParallelGroup()  //na sobe
									.addComponent(lblName)
									.addComponent(lblSurname))
						.addGroup(layout.createParallelGroup()
									.addComponent(txtName)
									.addComponent(txtSurname, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, 200))); // nastavuje navic vlastnosti komponente

		//vertikalni pohled
		layout.setVerticalGroup(
				layout.createSequentialGroup() //pod sebou
						.addGroup(layout.createParallelGroup() //na sobe
											.addComponent(lblName)
											.addComponent(txtName, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE))
						.addGroup(layout.createParallelGroup()
											.addComponent(lblSurname)
											.addComponent(txtSurname, GroupLayout.PREFERRED_SIZE, GroupLayout.DEFAULT_SIZE, GroupLayout.PREFERRED_SIZE)));

		inputPanel.add(lblName);
		inputPanel.add(txtName);
		
		// ukazka GridLayout - mrizka 1 x 2
		GridLayout actionLayout = new GridLayout(1, 2);
		actionLayout.setHgap(5);
		actionLayout.setVgap(5);
		
		btnAnswer = new JButton("Answer");
		btnAnswer.addActionListener((ActionEvent e) -> {
			// ulozi vysledek
			result = txtName.getText() + " " + txtSurname.getText();
			setVisible(false);
		});
		
		btnRun = new JButton("Run");
		btnRun.addActionListener((ActionEvent e) -> {
			result = null; // hodnoty z dialogu nedodame - na to musi rozumne reagovat volajici
			setVisible(false);
		});
	
		actionPanel.setLayout(actionLayout);
		actionPanel.add(btnAnswer);
		actionPanel.add(btnRun);
		
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(lblWho, BorderLayout.NORTH);
		getContentPane().add(inputPanel, BorderLayout.CENTER);
		getContentPane().add(actionPanel, BorderLayout.SOUTH);
	  
		pack();
	}

	public String getResult() {
		return result;
	}

}
