package cz.upol.jj2.lab05;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.*;


/**
 * Zakladni koncepty a prvky Swing UI (Frame, Panel, layout, Button, Label, Menu, listener, ...)
 */
public class SimpleLayoutAndMenuForm extends JFrame {

    //komponenty mohou byt i jako lokalni promenne, ale takto k nim maji pristup vsechny metody (coz se casto hodi)
    private JPanel mainPanel;
    private JButton btn1;
    private JButton btn2;
    private JButton btn3;
    private JButton btn4;

    private JLabel lbl;

    private JMenuBar mainMenu;
    private JMenu menuFile;
    private JMenu menuEdit;

    public SimpleLayoutAndMenuForm() {
        super();

		this.setTitle("Simple layout and menu");

        // po uzavreni okna, budou prostredky s nim spojene odstraneny
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);

        //OBSAH OKNA S JEDNODUCHYM ROZLOZENIM

        // vytvori panel do ktereho budou vkladany dalsi komponenty
        mainPanel = new JPanel();

        // nastavi zpusob rozlozeni komponent v tomto panelu,
        // pripadne dalsi vlastnosti tohoto rozlozeni

        //mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
        mainPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 10, 10));

        lbl = new JLabel("?");

        // vytvori ctyri komponenty predstavujici tlacitka
        btn1 = new JButton("Foo");
        btn2 = new JButton("Bar");
        btn3 = new JButton("Baz");
        btn4 = new JButton("Qux");

        ActionListener al = (e) -> lbl.setText(((JButton)e.getSource()).getText());
        btn1.addActionListener(al);
        btn2.addActionListener(al);
        btn3.addActionListener(al);
        btn4.addActionListener(al);

        // vlozi prvky do panelu
        mainPanel.add(lbl);
        mainPanel.add(btn1);
        mainPanel.add(btn2);
        mainPanel.add(btn3);
        mainPanel.add(btn4);

        this.setContentPane(mainPanel);

        //MENU

        // vytvori objekt predstavujici hlavni radek menu
        mainMenu = new JMenuBar();

        // vytvori objekt menu: ,,File'' (pristupny pres Alt+F)
        menuFile = new JMenu("File");
        menuFile.setMnemonic(KeyEvent.VK_F);

        // vytvori polozku v menu a navaze na ni udalost
        JMenuItem menuItemNew = new JMenuItem("New");
        menuItemNew.addActionListener(e -> lbl.setText("?"));

        // pripoji polozku menu do menu
        menuFile.add(menuItemNew);

        // vytvori dalsi polozku v menu
        JMenuItem menuItemExit = new JMenuItem("Exit");

        // nastavi klavesovou zkratku
        menuItemExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.CTRL_MASK));
        menuItemExit.addActionListener((ActionEvent e) -> {
            System.out.println("So long!");
            // ukonceni prace s oknem
            setVisible(false);
            dispose();
        });
        menuFile.add(menuItemExit);

        // dalsi menu
        menuEdit = new JMenu("Edit");
        menuEdit.setMnemonic(KeyEvent.VK_E);

        mainMenu.add(menuFile);
        mainMenu.add(menuEdit);

        // nastavi formulari menu
        this.setJMenuBar(mainMenu);



        // muzeme nastavit preferovanou/maximalni/minimalni velikost okna
        //this.setPreferredSize(new Dimension(400, 500));

        // uzpusobi velikost okna vlozenym komponentam
        this.pack();
    }

}
